# -*- coding: utf-8 -*-
from setuphelpers import *
from string import ascii_letters

port = "6556"


def install():
    print("installing tis-check_mkagent")

    version_cmk = control["version"].split("-", 1)[0]

    for softs in installed_softwares("Check_MK Agent"):
        if Version(softs["version"]) < Version(version_cmk):
            print("Uninstalling previous version : {}".format(softs["version"]))
            run_notfatal(uninstall_cmd(softs["key"]))

    print("Installing Check_MK Agent {}".format(version_cmk))
    install_msi_if_needed("check_mk_agent.msi")

    print("Open firewall for incoming TCP connections on port %s" % port)
    if windows_version() < Version("6"):
        # XP
        run('netsh.exe firewall add portopening name="check_mkagent" port=%s protocol=TCP profile=private,domain' % port)
    else:
        run('netsh advfirewall firewall add rule name="check_mkagent %s" dir=in action=allow protocol=TCP localport=%s ' % (port, port))


def uninstall():
    if windows_version() < Version("6"):
        # XP
        run("netsh.exe firewall del portopening  port=%s protocol=TCP profile=private,domain" % port)
    else:
        run('netsh advfirewall firewall del rule name="check_mkagent %s"' % (port,))

